using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;

namespace Server
{
    public partial class Form1 : Form
    {
        CCube[] FCubes;

        IPEndPoint FBroadcast  = null;
        UdpClient  FClient     = null;
//        IPEndPoint FIPEndPoint = null;
//        UdpClient  FServer     = null;
//        Thread     FThread     = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Random LRandom = new Random();

            FCubes = new CCube[LRandom.Next(100,150) + 1];
            for(int LIndex = 0;LIndex < FCubes.Length; LIndex++)
            {
                FCubes[LIndex] = new CCube();
                FCubes[LIndex].Scale.X = LRandom.NextDouble() * 2;
                FCubes[LIndex].Scale.Y = LRandom.NextDouble() * 2;
                FCubes[LIndex].Scale.Z = LRandom.NextDouble() * 2;

                FCubes[LIndex].Pos.X = LRandom.NextDouble() * 125f;
                FCubes[LIndex].Pos.Y = LRandom.NextDouble() * 125f;
                FCubes[LIndex].Pos.Z = LRandom.NextDouble() * 125f;

                if(LRandom.Next(1,100) > 50)
                {
                    FCubes[LIndex].Pos.X = -FCubes[LIndex].Pos.X;
                }
                if(LRandom.Next(1,100) > 50)
                {
                    FCubes[LIndex].Pos.Y = -FCubes[LIndex].Pos.Y;
                }
                if(LRandom.Next(1,100) >= 50)
                {
                    FCubes[LIndex].Pos.Z = -FCubes[LIndex].Pos.Z;
                }

                FCubes[LIndex].ScaleMultiplier = LRandom.Next(15,25);
            }

            FCubes[0].Scale.X = 1F;
            FCubes[0].Scale.Y = 1F;
            FCubes[0].Scale.Z = 1F;

            FCubes[0].Pos.X = 0F;
            FCubes[0].Pos.Y = 0F;
            FCubes[0].Pos.Z = 0F;

            FCubes[0].ScaleMultiplier = 20F;

            FBroadcast = new IPEndPoint(IPAddress.Broadcast, 9999);
            FClient = new UdpClient(9998);
            FClient.EnableBroadcast = true;

            /*
            FIPEndPoint = new IPEndPoint(IPAddress.Any, 9999);
            FServer = new UdpClient(9999);
            FServer.EnableBroadcast = true;
            FServer.MulticastLoopback = true;

            FThread = new Thread(new ThreadStart(StartServer));
            FThread.IsBackground = true;
            FThread.Start();
            */

            timer1.Enabled = true;
        }

        /*    
                public void StartServer()
                {
                    while (true)
                    {
                        byte[] Data = FServer.Receive(ref FIPEndPoint);

                        this.Invoke(new EventHandler(delegate(object sender2, EventArgs args2) { richTextBox1.Clear(); AddLine(Encoding.ASCII.GetString(Data)); }));
                    }
                }

                private void AddLine(String aString)
                {
                    richTextBox1.AppendText(aString + '\n'); 
                }

                private void button1_Click(object sender,EventArgs e)
                {
                    byte[] Data = Encoding.ASCII.GetBytes(textBox1.Text);

                    FClient.Send(Data, Data.Length, FBroadcast);
                    textBox1.Text = "";
                }
        */

        private void timer1_Tick(object sender,EventArgs e)
        {
            Random LRandom = new Random();

            foreach (CCube LCube in FCubes)
            {
                LCube.Rot.X += CCoordinate.DegToRad(LRandom.NextDouble() / 5D);
                LCube.Rot.Y += CCoordinate.DegToRad(LRandom.NextDouble() / 5D);
                LCube.Rot.Z += CCoordinate.DegToRad(LRandom.NextDouble() / 5D);
            }

            byte[] LData = new byte[CCube.ByteSize * FCubes.Length + 3 + sizeof(byte)];
            LData[0] = (byte)'M';
            LData[1] = (byte)'T';
            LData[2] = (byte)'R';
            LData[3] = (byte)FCubes.Length;

            if (checkBox1.Checked)
            {
                richTextBox1.Clear();
                richTextBox1.AppendText("MTR{L:" + String.Format("{0:D}", FCubes.Length) + "}\n");
            }

            int LPos = 4;
            foreach (CCube LCube in FCubes)
            {
                LCube.GetBytes().CopyTo(LData, LPos);
                LPos += CCube.ByteSize;

                if (checkBox1.Checked)
                {
                    richTextBox1.AppendText("[{P:" + String.Format("{0:F};{1:F};{2:F}", LCube.Pos.X, LCube.Pos.Y, LCube.Pos.Z) + "}\n");
                    richTextBox1.AppendText("[{R:" + String.Format("{0:F};{1:F};{2:F}", LCube.Rot.X, LCube.Rot.Y, LCube.Rot.Z) + "}\n");
                    richTextBox1.AppendText("[{S:" + String.Format("{0:F};{1:F};{2:F}", LCube.Scale.X, LCube.Scale.Y, LCube.Scale.Z) + "}\n");

                    richTextBox1.AppendText("{M:" + String.Format("{0:F}", LCube.ScaleMultiplier) + "}]\n");
                }
            }

            LData = new ASCIIEncoding().GetBytes(Convert.ToBase64String(LData));
            FClient.Send(LData, LData.Length, FBroadcast);
        }
    }

    public class CCoordinate
    {
        protected double FX;
        protected double FY;
        protected double FZ;

        public delegate void OnChangedHandler(CCoordinate ACoordinate,double AOldX,double AOldY,double AOldZ);

        public event OnChangedHandler OnAssigned;

        protected virtual void RaiseOnAssigned(double AOldX,double AOldY,double AOldZ)
        {
            if(OnAssigned != null)
            {
                OnAssigned(this,AOldX,AOldY,AOldZ);
            }
        }

        public CCoordinate()
        {
            FX = 0D;
            FY = 0D;
            FZ = 0D;
        }

        public CCoordinate(double AX,double AY,double AZ)
        {
            FX = AX;
            FY = AY;
            FZ = AZ;
        }

        public static int ByteSize
        {
            get
            {
                return (sizeof(double) * 3);
            }
        }

        public byte[] GetBytes()
        {
            byte[] LResult = new byte[ByteSize];
            
            byte[] LX = BitConverter.GetBytes(FX);
            byte[] LY = BitConverter.GetBytes(FY);
            byte[] LZ = BitConverter.GetBytes(FZ);

            LX.CopyTo(LResult, (sizeof(double) * 0));
            LY.CopyTo(LResult, (sizeof(double) * 1));
            LZ.CopyTo(LResult, (sizeof(double) * 2));

            return LResult;
        }

        
        public bool SetBytes(byte[] ABytes, int AOffset)
        {
            bool LResult = false;

            if (((ABytes.Length - AOffset) >= ByteSize) && (AOffset >= 0))
            {
                Assign(BitConverter.ToDouble(ABytes, (sizeof(double) * 0) + AOffset),
                       BitConverter.ToDouble(ABytes, (sizeof(double) * 1) + AOffset),
                       BitConverter.ToDouble(ABytes, (sizeof(double) * 2) + AOffset));

                LResult = true;
            }

            return LResult;
        }

        public double X
        {
            get
            {
                return FX;
            }

            set
            {
                Assign(value,FY,FZ);
            }
        }

        public float Xf
        {
            get
            {
                return (float)(FX);
            }

            set
            {
                Assign((double)(value),FY,FZ);
            }
        }

        public double Y
        {
            get
            {
                return FY;
            }

            set
            {
                Assign(FX,value,FZ);
            }
        }

        public float Yf
        {
            get
            {
                return (float)(FY);
            }

            set
            {
                Assign(FX,(double)(value),FZ);
            }
        }

        public double Z
        {
            get
            {
                return FZ;
            }

            set
            {
                Assign(FX,FY,value);
            }
        }

        public float Zf
        {
            get
            {
                return (float)(FZ);
            }

            set
            {
                Assign(FX,FY,(double)(value));
            }
        }

        public bool Assign(double AX,double AY,double AZ)
        {
            double LX = FX;
            double LY = FY;
            double LZ = FZ;

            FX = AX;
            FY = AY;
            FZ = AZ;

            RaiseOnAssigned(LX,LY,LZ);

            return true;
        }

        public bool Assign(CCoordinate ACoordinate)
        {
            bool LResult = false;

            if(ACoordinate != null)
            {
                LResult = Assign(ACoordinate.X,ACoordinate.Y,ACoordinate.Z);
            }

            return LResult;
        }

        public bool Equals(double AX,double AY,double AZ)
        {
            return ((FX == AX) && (FY == AY) && (FZ == AZ));
        }

        public bool Equals(CCoordinate ACoordinate)
        {
            bool LResult = false;

            if(ACoordinate != null)
            {
                LResult = Equals(ACoordinate.X,ACoordinate.Y,ACoordinate.Z);
            }

            return LResult;
        }

        public bool Rotate(double AX,double AY,double AZ,bool APositive)
        {
            double LTempX = FX;
            double LTempY = FY;
            double LTempZ = FZ;

            if(APositive)
            {
                // rotation around Z axis
                FX = LTempX * Math.Cos(AZ) - LTempY * Math.Sin(AZ);
                FY = LTempX * Math.Sin(AZ) + LTempY * Math.Cos(AZ);
                FZ = LTempZ;

                // save temporarily
                LTempX = FX;
                LTempY = FY;
                LTempZ = FZ;

                // rotation around Y axis
                FX = LTempZ * Math.Sin(AY) + LTempX * Math.Cos(AY);
                FY = LTempY;
                FZ = LTempZ * Math.Cos(AY) - LTempX * Math.Sin(AY);

                // save temporarily
                LTempX = FX;
                LTempY = FY;
                LTempZ = FZ;

                // rotation around X axis
                FX = LTempX;
                FY = LTempY * Math.Cos(AX) - LTempZ * Math.Sin(AX);
                FZ = LTempY * Math.Sin(AX) + LTempZ * Math.Cos(AX);
            }
            else
            {
                // rotation around X axis
                FX = LTempX;
                FY = LTempY * Math.Cos(- AX) - LTempZ * Math.Sin(- AX);
                FZ = LTempY * Math.Sin(- AX) + LTempZ * Math.Cos(- AX);

                // save temporarily
                LTempX = FX;
                LTempY = FY;
                LTempZ = FZ;

                // rotation around Y axis
                FX = LTempZ * Math.Sin(- AY) + LTempX * Math.Cos(- AY);
                FY = LTempY;
                FZ = LTempZ * Math.Cos(- AY) - LTempX * Math.Sin(- AY);

                // save temporarily
                LTempX = FX;
                LTempY = FY;
                LTempZ = FZ;

                // rotation around Z axis
                FX = LTempX * Math.Cos(- AZ) - LTempY * Math.Sin(- AZ);
                FY = LTempX * Math.Sin(- AZ) + LTempY * Math.Cos(- AZ);
                FZ = LTempZ;
            }

            return true;
        }

        public bool Rotate(CCoordinate ACoordinate,bool APositive)
        {
            bool LResult = false;

            if(ACoordinate != null)
            {
                LResult = Rotate(ACoordinate.X,ACoordinate.Y,ACoordinate.Z,APositive);
            }

            return LResult;
        }

        public bool Scale(double AX,double AY,double AZ,double AMultiplier,bool APositive)
        {
            bool LResult = false;

            if(APositive)
            {
                FX *= AX * AMultiplier;
                FY *= AY * AMultiplier;
                FZ *= AZ * AMultiplier;

                LResult = true;
            }
            else
            {
                if((AMultiplier != 0D) && (AX != 0D) && (AY != 0D) && (AZ != 0D))
                {
                    FX /= AX * AMultiplier;
                    FY /= AY * AMultiplier;
                    FZ /= AZ * AMultiplier;

                    LResult = true;
                }
            }

            return LResult;
        }

        public bool Scale(CCoordinate ACoordinate,double AMultiplier,bool APositive)
        {
            bool LResult = false;

            if(ACoordinate != null)
            {
                LResult = Scale(ACoordinate.X,ACoordinate.Y,ACoordinate.Z,AMultiplier,APositive);
            }

            return LResult;
        }

        public bool Translate(double AX,double AY,double AZ,bool APositive)
        {
            if(APositive)
            {
                FX += AX;
                FY += AY;
                FZ += AZ;
            }
            else
            {
                FX -= AX;
                FY -= AY;
                FZ -= AZ;
            }

            return true;
        }

        public bool Translate(CCoordinate ACoordinate,bool APositive)
        {
            bool LResult = false;

            if(ACoordinate != null)
            {
                LResult = Translate(ACoordinate.X,ACoordinate.Y,ACoordinate.Z,APositive);
            }

            return LResult;
        }

        public static double DegToRad(double AAngle)
        {
            return (AAngle / 180D) * Math.PI;
        }

        public static double RadToDeg(double AAngle)
        {
            return (AAngle / Math.PI) * 180D;
        }
    }

    public class CCube
    {
        protected CCoordinate[,] FMatrix;
        protected CCoordinate[] FPoints;

        protected CCoordinate FPos   = null;
        protected CCoordinate FRot   = null;
        protected CCoordinate FScale = null;

        protected double FScaleMultiplier = 1D;

        protected void OnAssignedPos(CCoordinate ACoordinate,double AOldX,double AOldY,double AOldZ)
        {
            if(!(FPos.Equals(AOldX,AOldY,AOldZ)))
            {
                foreach(CCoordinate LIndex in FPoints)
                {
                    LIndex.Translate(AOldX,AOldY,AOldZ,false);

                    LIndex.Translate(FPos,true);
                }
            }
        }

        protected void OnAssignedRot(CCoordinate ACoordinate,double AOldX,double AOldY,double AOldZ)
        {
            if(!(FRot.Equals(AOldX,AOldY,AOldZ)))
            {
                foreach(CCoordinate LIndex in FPoints)
                {
                    LIndex.Translate(FPos,false);
                    LIndex.Rotate(AOldX,AOldY,AOldZ,false);

                    LIndex.Rotate(FRot,true);
                    LIndex.Translate(FPos,true);
                }
            }
        }

        protected void OnAssignedScale(CCoordinate ACoordinate,double AOldX,double AOldY,double AOldZ)
        {
            if(!(FScale.Equals(AOldX,AOldY,AOldZ)))
            {
                foreach(CCoordinate LIndex in FPoints)
                {
                    LIndex.Translate(FPos,false);
                    LIndex.Rotate(FRot,false);
                    LIndex.Scale(AOldX,AOldY,AOldZ,FScaleMultiplier,false);

                    LIndex.Scale(FScale,FScaleMultiplier,true);
                    LIndex.Rotate(FRot,true);
                    LIndex.Translate(FPos,true);
                }
            }
        }

        public CCube()
        {
            FPoints    = new CCoordinate[8];
            FPoints[0] = new CCoordinate(-0.5D,-0.5D,-0.5D);
            FPoints[1] = new CCoordinate(+0.5D,-0.5D,-0.5D);
            FPoints[2] = new CCoordinate(-0.5D,+0.5D,-0.5D);
            FPoints[3] = new CCoordinate(-0.5D,-0.5D,+0.5D);
            FPoints[4] = new CCoordinate(+0.5D,+0.5D,-0.5D);
            FPoints[5] = new CCoordinate(+0.5D,-0.5D,+0.5D);
            FPoints[6] = new CCoordinate(-0.5D,+0.5D,+0.5D);
            FPoints[7] = new CCoordinate(+0.5D,+0.5D,+0.5D);

            FMatrix = new CCoordinate[6,4];

            // top
            FMatrix[0,0] = FPoints[2];
            FMatrix[0,1] = FPoints[6];
            FMatrix[0,2] = FPoints[7];
            FMatrix[0,3] = FPoints[4];

            // bottom
            FMatrix[1,0] = FPoints[1];
            FMatrix[1,1] = FPoints[5];
            FMatrix[1,2] = FPoints[3];
            FMatrix[1,3] = FPoints[0];

            // left
            FMatrix[2,0] = FPoints[2];
            FMatrix[2,1] = FPoints[0];
            FMatrix[2,2] = FPoints[3];
            FMatrix[2,3] = FPoints[6];

            // right
            FMatrix[3,0] = FPoints[7];
            FMatrix[3,1] = FPoints[5];
            FMatrix[3,2] = FPoints[1];
            FMatrix[3,3] = FPoints[4];

            // front
            FMatrix[4,0] = FPoints[6];
            FMatrix[4,1] = FPoints[3];
            FMatrix[4,2] = FPoints[5];
            FMatrix[4,3] = FPoints[7];

            // back
            FMatrix[5,0] = FPoints[4];
            FMatrix[5,1] = FPoints[1];
            FMatrix[5,2] = FPoints[0];
            FMatrix[5,3] = FPoints[2];

            FPos   = new CCoordinate(0D,0D,0D);
            FRot   = new CCoordinate(0D,0D,0D);
            FScale = new CCoordinate(1D,1D,1D);

            FPos.OnAssigned   += new CCoordinate.OnChangedHandler(OnAssignedPos);
            FRot.OnAssigned   += new CCoordinate.OnChangedHandler(OnAssignedRot);
            FScale.OnAssigned += new CCoordinate.OnChangedHandler(OnAssignedScale);

            FScaleMultiplier = 1D;
        }

        public static int ByteSize
        {
            get
            {
                return ((CCoordinate.ByteSize * 3) + (sizeof(double) * 1));
            }
        }

        public byte[] GetBytes()
        {
            byte[] LResult = new byte[ByteSize];

            byte[] LPos   = FPos.GetBytes();
            byte[] LRot   = FRot.GetBytes();
            byte[] LScale = FScale.GetBytes();

            byte[] LScaleMultiplier = BitConverter.GetBytes(FScaleMultiplier);

            LPos.CopyTo(LResult,   (CCoordinate.ByteSize * 0));
            LRot.CopyTo(LResult,   (CCoordinate.ByteSize * 1));
            LScale.CopyTo(LResult, (CCoordinate.ByteSize * 2));

            LScaleMultiplier.CopyTo(LResult, (CCoordinate.ByteSize * 3));

            return LResult;
        }

        public bool SetBytes(byte[] ABytes, int AOffset)
        {
            bool LResult = false;

            if(((ABytes.Length - AOffset) >= ByteSize) && (AOffset >= 0))
            {
                FPos.SetBytes(ABytes,   (CCoordinate.ByteSize * 0) + AOffset);
                FRot.SetBytes(ABytes,   (CCoordinate.ByteSize * 1) + AOffset);
                FScale.SetBytes(ABytes, (CCoordinate.ByteSize * 2) + AOffset);

                ScaleMultiplier = BitConverter.ToDouble(ABytes, (CCoordinate.ByteSize * 3) + AOffset);

                LResult = true;
            }

            return LResult;
        }

        public double ScaleMultiplier
        {
            get
            {
                return FScaleMultiplier;
            }

            set
            {
                if(value != FScaleMultiplier)
                {
                    foreach(CCoordinate LIndex in FPoints)
                    {
                        LIndex.Translate(FPos,false);
                        LIndex.Rotate(FRot,false);
                        LIndex.Scale(FScale,FScaleMultiplier,false);

                        LIndex.Scale(FScale,value,true);
                        LIndex.Rotate(FRot,true);
                        LIndex.Translate(FPos,true);
                    }

                    FScaleMultiplier = value;
                }
            }
        }

        public CCoordinate Pos
        {
            get
            {
                return FPos;
            }

            set
            {
                if(!(FPos.Equals(value)))
                {
                    foreach(CCoordinate LIndex in FPoints)
                    {
                        LIndex.Translate(FPos,false);

                        LIndex.Translate(value,true);
                    }

                    FPos.Assign(value);
                }
            }
        }

        public CCoordinate Rot
        {
            get
            {
                return FRot;
            }

            set
            {
                if(!(FRot.Equals(value)))
                {
                    foreach(CCoordinate LIndex in FPoints)
                    {
                        LIndex.Translate(FPos,false);
                        LIndex.Rotate(FRot,false);

                        LIndex.Rotate(value,true);
                        LIndex.Translate(FPos,true);
                    }

                    FRot.Assign(value);
                }
            }
        }

        public CCoordinate Scale
        {
            get
            {
                return FScale;
            }

            set
            {
                if(!(FScale.Equals(value)))
                {
                    foreach(CCoordinate LIndex in FPoints)
                    {
                        LIndex.Translate(FPos,false);
                        LIndex.Rotate(FRot,false);
                        LIndex.Scale(FScale,FScaleMultiplier,false);

                        LIndex.Scale(value,FScaleMultiplier,true);
                        LIndex.Rotate(FRot,true);
                        LIndex.Translate(FPos,true);
                    }

                    FScale.Assign(value);
                }
            }
        }

        public bool IsCollision(double AX,double AY,double AZ,bool ADraw,ref double ANewY)
        {
            bool LResult = false;

            double LXmax = FPoints[0].X;
            double LXmin = FPoints[0].X;
            double LYmax = FPoints[0].Y;
            double LYmin = FPoints[0].Y;
            double LZmax = FPoints[0].Z;
            double LZmin = FPoints[0].Z;

            for(int LIndex = 1;LIndex < FPoints.GetLength(0);LIndex++)
            {
                if(FPoints[LIndex].X < LXmin)
                {
                    LXmin = FPoints[LIndex].X;
                }
                if(FPoints[LIndex].X > LXmax)
                {
                    LXmax = FPoints[LIndex].X;
                }

                if(FPoints[LIndex].Y < LYmin)
                {
                    LYmin = FPoints[LIndex].Y;
                }
                if(FPoints[LIndex].Y > LYmax)
                {
                    LYmax = FPoints[LIndex].Y;
                }

                if(FPoints[LIndex].Z < LZmin)
                {
                    LZmin = FPoints[LIndex].Z;
                }
                if(FPoints[LIndex].Z > LZmax)
                {
                    LZmax = FPoints[LIndex].Z;
                }
            }

            LResult = ((LXmin <= AX) && (LXmax >= AX) && (LYmin - 1 <= AY) && (LYmax + 1 >= AY) && (LZmin <= AZ) && (LZmax >= AZ));
            if(LResult)
            {
                ANewY = LYmax;
            }

            return LResult;
        }
    }
}