using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Net;
using System.Net.Sockets;

namespace UDPtest
{
    public partial class Form1 : Form
    {
        IPEndPoint FBroadcast  = null;
        UdpClient  FClient     = null;
        IPEndPoint FIPEndPoint = null;
        UdpClient  FServer     = null;
        Thread     FThread     = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            FBroadcast = new IPEndPoint(IPAddress.Broadcast, 9999);
            FClient = new UdpClient(9998);
            FClient.EnableBroadcast = true;

            FIPEndPoint = new IPEndPoint(IPAddress.Any, 9999);
            FServer = new UdpClient(9999);
            FServer.EnableBroadcast = true;

            FThread = new Thread(new ThreadStart(StartServer));
            FThread.IsBackground = true;
            FThread.Start();
        }

        public void StartServer()
        {
            while (true)
            {
                byte[] Data = FServer.Receive(ref FIPEndPoint);
              
                this.Invoke(new EventHandler(delegate (object sender2, EventArgs args2){ AddLine(Encoding.ASCII.GetString(Data)); }));
            }
        }

        private void AddLine(String aString)
        {
            richTextBox1.AppendText(aString + '\n'); 
        }

        private void button1_Click(object sender,EventArgs e)
        {
            byte[] Data = Encoding.ASCII.GetBytes(textBox1.Text);

            FClient.Send(Data, Data.Length, FBroadcast);
            textBox1.Text = "";
        }
    }
}